package com.ruixuan.isc.service.impl;


import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.google.gson.Gson;
import com.kuaidi100.sdk.api.Subscribe;
import com.kuaidi100.sdk.contant.ApiInfoConstant;
import com.kuaidi100.sdk.contant.CompanyConstant;
import com.kuaidi100.sdk.core.IBaseClient;
import com.kuaidi100.sdk.request.SubscribeParam;
import com.kuaidi100.sdk.request.SubscribeParameters;
import com.kuaidi100.sdk.request.SubscribeReq;
import com.ruixuan.common.utils.Check;
import com.ruixuan.common.utils.DateUtils;
import com.ruixuan.isc.entity.KuaishouItemCollectSamples;
import com.ruixuan.isc.mapper.KuaishouItemCollectSamplesMapper;
import com.ruixuan.isc.service.IKuaishouItemCollectSamplesService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author ruoyi
 * @date 2023-02-08
 */
@Service
public class KuaishouItemCollectSamplesServiceImpl implements IKuaishouItemCollectSamplesService {
    @Autowired
    private KuaishouItemCollectSamplesMapper kuaishouItemCollectSamplesMapper;

    /**
     * 查询【请填写功能名称】
     *
     * @param id 【请填写功能名称】主键
     * @return 【请填写功能名称】
     */
    @Override
    public KuaishouItemCollectSamples selectKuaishouItemCollectSamplesById(Long id) {
        return kuaishouItemCollectSamplesMapper.selectKuaishouItemCollectSamplesById(id);
    }

    /**
     * 查询【请填写功能名称】列表
     *
     * @param requestMap 【请填写功能名称】
     * @return 【请填写功能名称】
     */
    @Override
    public List<KuaishouItemCollectSamples> selectKuaishouItemCollectSamplesList(Map<String, Object> requestMap) {
        return kuaishouItemCollectSamplesMapper.selectKuaishouItemCollectSamplesList(requestMap);
    }

    /**
     * 新增【请填写功能名称】
     *
     * @param kuaishouItemCollectSamples 【请填写功能名称】
     * @return 结果
     */
    @Override
    public int insertKuaishouItemCollectSamples(KuaishouItemCollectSamples kuaishouItemCollectSamples) {
        kuaishouItemCollectSamples.setCreateTime(DateUtils.getNowDate());
        return kuaishouItemCollectSamplesMapper.insertKuaishouItemCollectSamples(kuaishouItemCollectSamples);
    }

    /**
     * 修改【请填写功能名称】
     *
     * @param kuaishouItemCollectSamples 【请填写功能名称】
     * @return 结果
     */
    @Override
    public int updateKuaishouItemCollectSamples(KuaishouItemCollectSamples kuaishouItemCollectSamples) {
        kuaishouItemCollectSamples.setUpdateTime(DateUtils.getNowDate());
        return kuaishouItemCollectSamplesMapper.updateKuaishouItemCollectSamples(kuaishouItemCollectSamples);
    }

    /**
     * 批量删除【请填写功能名称】
     *
     * @param ids 需要删除的【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int deleteKuaishouItemCollectSamplesByIds(Long[] ids) {
        return kuaishouItemCollectSamplesMapper.deleteKuaishouItemCollectSamplesByIds(ids);
    }

    /**
     * 删除【请填写功能名称】信息
     *
     * @param id 【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int deleteKuaishouItemCollectSamplesById(Long id) {
        return kuaishouItemCollectSamplesMapper.deleteKuaishouItemCollectSamplesById(id);
    }

    @Override
    public JSONObject preview(Long userId, String nickName, JSONArray itemIds, JSONArray promoterIds) {
        JSONObject previewJson = new JSONObject();
        List<JSONObject> itemList = kuaishouItemCollectSamplesMapper.getItemList(itemIds);
        Map<Long, JSONObject> itemMap = new HashMap<>();
        for (int i = 0; i < itemList.size(); i++) {
            JSONObject itemJson = itemList.get(i);
            itemMap.put(itemJson.getLong("itemId"), itemJson);
        }
        Map<Long, JSONObject> promoterMap = new HashMap<>();
        List<JSONObject> promoterList = kuaishouItemCollectSamplesMapper.promoterList(promoterIds);
        for (int i = 0; i < promoterList.size(); i++) {
            JSONObject promoterJson = promoterList.get(i);
            promoterMap.put(promoterJson.getLong("promoterId"), promoterJson);
        }
        Integer sampleReceivedCount = 0;
        List<JSONObject> samples = new ArrayList<>();
        for (int i = 0; i < itemIds.size(); i++) {
            Long itemId = itemIds.getLong(i);
            JSONObject itemJson = itemMap.get(itemId);
            for (int j = 0; j < promoterIds.size(); j++) {
                Long promoterId = promoterIds.getLong(j);
                Integer count = kuaishouItemCollectSamplesMapper.check(itemId, promoterId);
                if (count > 0) {
                    sampleReceivedCount++;
                    continue;
                }
                JSONObject sampleJson = new JSONObject();
                sampleJson.put("itemId", itemJson.getLong("itemId"));
                sampleJson.put("itemTitle", itemJson.getLong("itemTitle"));
                sampleJson.put("itemPrice", itemJson.getLong("itemPrice"));
                sampleJson.put("itemMgUrl", itemJson.getString("itemMgUrl"));
                sampleJson.put("commissionRate", itemJson.getLong("commissionRate"));
                sampleJson.put("regimentalPromotion", itemJson.getLong("regimentalPromotion"));
                sampleJson.put("itemCreateId", itemJson.getLong("userId"));
                sampleJson.put("itemCreateName", itemJson.getString("userName"));
                sampleJson.put("collectSampleId", userId);
                sampleJson.put("collectSampleName", nickName);
                JSONObject promoterJson = promoterMap.get(promoterId);
                sampleJson.put("promoterId", promoterJson.getLong("promoterId"));
                sampleJson.put("promoterNickName", promoterJson.getString("promoterNickName"));
                sampleJson.put("promoterPhone", promoterJson.getString("promoterPhone"));
                sampleJson.put("promoterAddress", promoterJson.getString("promoterAddress"));
                sampleJson.put("promoterUrl", promoterJson.getString("promoterUrl"));
                sampleJson.put("collectSampleStatus", 1);
                sampleJson.put("collectSampleDesc", "待招商审核");
                samples.add(sampleJson);
            }
            previewJson.put("sampleReceivedCount", sampleReceivedCount);
            previewJson.put("samples", samples);
        }


        return previewJson;
    }

    @Override
    public void batchAdd(JSONArray temCollectSamples) {

        List<KuaishouItemCollectSamples> adds = new ArrayList<>();
        for (int i = 0; i < temCollectSamples.size(); i++) {
            JSONObject sampleJson = temCollectSamples.getJSONObject(i);
            KuaishouItemCollectSamples sample = new KuaishouItemCollectSamples();
            sample.setItemId(sampleJson.getLong("item_id"));
            sample.setItemTitle(sampleJson.getString("item_title"));
            sample.setItemPrice(sampleJson.getLong("item_price"));
            sample.setItemMgUrl(sampleJson.getString("item_mg_url"));
            sample.setItemDesc(sampleJson.getString("item_desc"));
            sample.setCommissionRate(sampleJson.getLong("commission_rate"));
            sample.setRegimentalPromotion(sampleJson.getLong("regimental_promotion"));
            sample.setSampleCount(sampleJson.getInteger("sample_count"));
            sample.setSampleRequirement(sampleJson.getString("sample_requirement"));
            sample.setItemId(sampleJson.getLong("item_create_id"));
            sample.setItemCreateName(sampleJson.getString("item_create_name"));
            sample.setCollectSampleId(sampleJson.getLong("collect_sample_id"));
            sample.setCollectSampleName(sampleJson.getString("collect_sample_name"));
            sample.setPartnerRecommendText(sampleJson.getString("partner_recommend_text"));
            sample.setPromoterId(sampleJson.getLong("promoter_id"));
            sample.setPromoterPhone(sampleJson.getString("promoter_phone"));
            sample.setPromoterAddress(sampleJson.getString("promoter_address"));
            sample.setCollectSampleStatus(sampleJson.getInteger("collect_sample_status"));
            sample.setCollectSampleDesc(sampleJson.getString("collect_sample_desc"));
            adds.add(sample);
        }
        if(!Check.isNull(adds)){
            kuaishouItemCollectSamplesMapper.batchAdd(adds);
        }

    }

    @Override
    public void subscribe(Long id, String courierNumber) throws Exception {

        KuaishouItemCollectSamples samples = kuaishouItemCollectSamplesMapper.selectKuaishouItemCollectSamplesById(id);

        SubscribeParameters subscribeParameters = new SubscribeParameters();
        subscribeParameters.setCallbackurl("http://ruixuan.api.tjyourong.com.cn/itemCollectSamples/callback");
        subscribeParameters.setPhone(samples.getPromoterPhone());

        SubscribeParam subscribeParam = new SubscribeParam();
        subscribeParam.setParameters(subscribeParameters);
        subscribeParam.setCompany(CompanyConstant.ST);
        subscribeParam.setNumber(courierNumber);
        subscribeParam.setKey("BPEQUJxB9244");

        SubscribeReq subscribeReq = new SubscribeReq();
        subscribeReq.setSchema(ApiInfoConstant.SUBSCRIBE_SCHEMA);
        subscribeReq.setParam(new Gson().toJson(subscribeParam));

        IBaseClient subscribe = new Subscribe();
        System.out.println(subscribe.execute(subscribeReq));
    }




}

