package com.ruixuan.isc.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.ruixuan.common.utils.Check;
import com.ruixuan.isc.mapper.SupplyChainMapper;
import com.ruixuan.isc.service.ISupplyChainService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Service
public class SupplyChainServiceImpl implements ISupplyChainService {
    @Autowired
    private SupplyChainMapper supplyChainMapper;

    // 获取订单数据　
    @Override
    public List<JSONObject> getOrderList(Map<String, Object> requestMap) {
        List<JSONObject> list = supplyChainMapper.getOrderList(requestMap);
        if (!Check.isNull(list)) {
            for (int i = 0; i < list.size(); i++) {
                JSONObject jsonObject = list.get(i);
                Long promoterId = jsonObject.getLong("promoterId");
                requestMap.put("promoterId", promoterId);
                List<JSONObject> topOrders = supplyChainMapper.getTopOrders(requestMap);
                jsonObject.put("topOrders", topOrders);
            }
        }
        return list;
    }

    //达人带货详情
    @Override
    public List<JSONObject> anchorOrderDetail(Map<String, Object> requestMap) {
        return supplyChainMapper.anchorOrderDetail(requestMap);
    }

    //订单统计
    @Override
    public List<JSONObject> orderStatistics(Map<String, Object> requestMap) {
        return supplyChainMapper.orderStatistics(requestMap);
    }

    //商品列表
    @Override
    public List<JSONObject> itemList(Map<String, Object> requestMap) {
        List<JSONObject> list = supplyChainMapper.itemList(requestMap);

        return list;
    }

    @Override
    public List<JSONObject> itemDetail(Map<String, Object> requestMap) {
        return supplyChainMapper.itemDetail(requestMap);
    }

    @Override
    public List<JSONObject> itemServiceCharge(Map<String, Object> requestMap) {
        return supplyChainMapper.itemServiceCharge(requestMap);
    }

    @Override
    public JSONObject getOrderTotal(Map<String, Object> requestMap) {
        return supplyChainMapper.getOrderTotal(requestMap);
    }

    @Override
    public Double getOrderTotalRatio(Map<String, Object> ratioMap) {
        return supplyChainMapper.getOrderTotalRatio(ratioMap);
    }

    @Override
    public JSONObject getAmountTotal(Map<String, Object> requestMap) {
        return supplyChainMapper.getAmountTotal(requestMap);
    }

    @Override
    public Double getAmountTotalRatio(Map<String, Object> ratioMap) {
        return supplyChainMapper.getAmountTotalRatio(ratioMap);
    }

    @Override
    public JSONObject getServiceAmountTotal(Map<String, Object> requestMap) {
        return supplyChainMapper.getServiceAmountTotal(requestMap);
    }

    @Override
    public List<JSONObject> getOrderRankRatioList(Map<String, Object> requestMap) {
        return supplyChainMapper.getOrderRankRatioList(requestMap);
    }

    @Override
    public List<JSONObject> getOrderRankList(Map<String, Object> requestMap) {
        return supplyChainMapper.getOrderRankList(requestMap);
    }

    @Override
    public List<JSONObject> getPromoterRankRatioList(Map<String, Object> requestMap) {
        return supplyChainMapper.getPromoterRankRatioList(requestMap);
    }

    @Override
    public List<JSONObject> getPromoterRatioList(Map<String, Object> requestMap) {
        return supplyChainMapper.getPromoterRatioList(requestMap);
    }

    @Override
    public List<JSONObject> exportPromoterTotal(Map<String, Object> requestMap) {
        return supplyChainMapper.exportPromoterTotal(requestMap);
    }

    @Override
    public List<JSONObject> exportPromoter(Map<String, Object> requestMap) {
        return supplyChainMapper.exportPromoter(requestMap);
    }

    @Override
    public List<JSONObject> exportOrder(Map<String, Object> requestMap) {
        return supplyChainMapper.exportOrder(requestMap);
    }

    @Override
    public List<JSONObject> getTopPromoterByItemId(Map<String, Object> requestMap) {
        return supplyChainMapper.getTopPromoterByItemId(requestMap);
    }

    @Override
    public List<JSONObject> bindUserItemList(Map<String, Object> requestMap) {
        return supplyChainMapper.bindUserItemList(requestMap);
    }

    @Override
    public List<JSONObject> getSupplyChainUserList() {
        return supplyChainMapper.getSupplyChainUserList();
    }

    @Override
    public boolean unbindUser(Long itemId) {
        return supplyChainMapper.unbindUser(itemId);
    }

    @Override
    public boolean bindUser(Long itemId, Long userId, String nikeName) {
        return supplyChainMapper.bindUser(itemId, userId, nikeName);
    }

    @Override
    public List<JSONObject> adminReportList(Map<String, Object> requestMap) {
        return supplyChainMapper.adminReportList(requestMap);
    }

    @Override
    public List<JSONObject> userItemDetail(Map<String, Object> requestMap) {
        return supplyChainMapper.userItemDetail(requestMap);
    }

    @Override
    public JSONObject getTimeIntervalRatio(Map<String, Object> requestMap) {
        return supplyChainMapper.getTimeIntervalRatio(requestMap);
    }

    @Override
    public List<JSONObject> indexStatistics(Map<String, Object> requestMap) {
        return supplyChainMapper.indexStatistics(requestMap);
    }

    @Override
    public JSONObject itemBindSummary() {
        return supplyChainMapper.itemBindSummary();
    }

    @Override
    public JSONObject userItemTotal(Map<String, Object> requestMap) {
        return supplyChainMapper.userItemTotal(requestMap);
    }

    @Override
    public List<JSONObject> exportUserItemDetail(Map<String, Object> requestMap) {
        return supplyChainMapper.exportUserItemDetail(requestMap);
    }
}
